diff --git a/test/unit/config_test.rb b/test/unit/config_test.rb
index f9b9a92d..4babe3e7 100644
--- a/test/unit/config_test.rb
+++ b/test/unit/config_test.rb
@@ -2896,6 +2896,49 @@ class ConfigTest < Minitest::Test
     end
   end
 
+  def test_daemon_auto_retry_enabled_defaults_true
+    cfg = Hive::Config::DEFAULTS.dig("daemon", "auto_retry", "enabled")
+    assert_equal true, cfg
+  end
+
+  def test_load_global_daemon_accepts_auto_retry_enabled_false
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), <<~YAML)
+        registered_projects: []
+        daemon:
+          auto_retry:
+            enabled: false
+      YAML
+      cfg = Hive::Config.load_global_daemon
+      assert_equal false, cfg.dig("auto_retry", "enabled")
+    end
+  end
+
+  def test_load_global_daemon_rejects_non_boolean_auto_retry_enabled
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), <<~YAML)
+        registered_projects: []
+        daemon:
+          auto_retry:
+            enabled: "yes"
+      YAML
+      err = assert_raises(Hive::ConfigError) { Hive::Config.load_global_daemon }
+      assert_match(/daemon.auto_retry.enabled.*must be a boolean/, err.message)
+    end
+  end
+
+  def test_load_global_daemon_rejects_non_hash_auto_retry
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), <<~YAML)
+        registered_projects: []
+        daemon:
+          auto_retry: true
+      YAML
+      err = assert_raises(Hive::ConfigError) { Hive::Config.load_global_daemon }
+      assert_match(/daemon.auto_retry.*must be a Hash/, err.message)
+    end
+  end
+
   def test_load_rejects_too_small_daemon_poll_interval
     with_tmp_dir do |dir|
       FileUtils.mkdir_p(File.join(dir, ".hive-state"))
diff --git a/test/unit/daemon/health_probes_test.rb b/test/unit/daemon/health_probes_test.rb
new file mode 100644
index 00000000..1c60e0dd
--- /dev/null
+++ b/test/unit/daemon/health_probes_test.rb
@@ -0,0 +1,174 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "fileutils"
+require "hive/daemon/health_probes"
+
+class HiveDaemonHealthProbesTest < Minitest::Test
+  NOW = Time.utc(2026, 7, 18, 12, 0, 0)
+
+  def setup
+    @tmpdir = Dir.mktmpdir("hive-health-probes")
+    @bin_dir = File.join(@tmpdir, "bin")
+    FileUtils.mkdir_p(@bin_dir)
+    @fake_hive = write_script("hive", <<~'SH')
+      #!/usr/bin/env bash
+      set -u
+      if [[ "${1:-}" == "--version" ]]; then
+        printf '%s\n' "${HIVE_FAKE_HIVE_VERSION:-0.3.2}"
+        exit 0
+      fi
+      if [[ "${1:-}" == "doctor" && "${2:-}" == "--json" ]]; then
+        if [[ -n "${HIVE_FAKE_DOCTOR_HANG:-}" ]]; then
+          sleep "${HIVE_FAKE_DOCTOR_HANG}"
+        fi
+        printf '%s\n' "${HIVE_FAKE_DOCTOR_JSON:-{\"schema\":\"hive-doctor.v1\",\"checks\":[],\"summary\":{\"missing\":0,\"version_too_old\":0,\"present\":0,\"not_applicable\":0,\"warning\":0}}}"
+        exit "${HIVE_FAKE_DOCTOR_EXIT:-0}"
+      fi
+      echo "fake-hive: unsupported $*" >&2
+      exit 99
+    SH
+    @fake_codex = write_script("codex", <<~'SH')
+      #!/usr/bin/env bash
+      set -u
+      if [[ "${1:-}" == "login" && "${2:-}" == "status" ]]; then
+        if [[ -n "${HIVE_FAKE_CODEX_LOGIN_HANG:-}" ]]; then
+          sleep "${HIVE_FAKE_CODEX_LOGIN_HANG}"
+        fi
+        printf '%s\n' "${HIVE_FAKE_CODEX_LOGIN_STDOUT:-Logged in as user@example.com}"
+        exit "${HIVE_FAKE_CODEX_LOGIN_EXIT:-0}"
+      fi
+      if [[ "${1:-}" == "exec" ]]; then
+        if [[ -n "${HIVE_FAKE_CODEX_EXEC_HANG:-}" ]]; then
+          sleep "${HIVE_FAKE_CODEX_EXEC_HANG}"
+        fi
+        printf '%s\n' "${HIVE_FAKE_CODEX_EXEC_STDOUT:-ok}"
+        exit "${HIVE_FAKE_CODEX_EXEC_EXIT:-0}"
+      fi
+      if [[ "${1:-}" == "--version" ]]; then
+        echo "codex-cli 0.139.0"
+        exit 0
+      fi
+      echo "fake-codex: unsupported $*" >&2
+      exit 99
+    SH
+  end
+
+  def teardown
+    FileUtils.remove_entry(@tmpdir) if @tmpdir && File.directory?(@tmpdir)
+  end
+
+  def write_script(name, body)
+    path = File.join(@bin_dir, name)
+    File.write(path, body)
+    File.chmod(0o755, path)
+    path
+  end
+
+  def probes(**opts)
+    Hive::Daemon::HealthProbes.new(
+      hive_bin: @fake_hive,
+      codex_bin: @fake_codex,
+      env: ENV.to_hash.merge(opts.fetch(:env, {})),
+      now_provider: -> { opts.fetch(:now, NOW) }
+    )
+  end
+
+  def test_codex_auth_suite_healthy_when_login_smoke_and_doctor_pass
+    result = probes.evaluate(reason: "implementer_failed", now: NOW)
+    assert result.healthy, "expected healthy, got #{result.inspect}"
+    assert result.probes["doctor"]
+    assert result.probes["codex_login"]
+    assert result.probes["codex_smoke"]
+    refute_nil result.fingerprint
+  end
+
+  def test_codex_auth_unhealthy_when_login_fails
+    ENV["HIVE_FAKE_CODEX_LOGIN_EXIT"] = "1"
+    ENV["HIVE_FAKE_CODEX_LOGIN_STDOUT"] = "Not logged in"
+    result = probes.evaluate(reason: "implementer_failed", now: NOW)
+    refute result.healthy
+    assert_equal "probe_failed:codex_login", result.rationale
+  ensure
+    ENV.delete("HIVE_FAKE_CODEX_LOGIN_EXIT")
+    ENV.delete("HIVE_FAKE_CODEX_LOGIN_STDOUT")
+  end
+
+  def test_doctor_nonzero_is_unhealthy
+    ENV["HIVE_FAKE_DOCTOR_EXIT"] = "65"
+    ENV["HIVE_FAKE_DOCTOR_JSON"] = '{"schema":"hive-doctor.v1","checks":[],"summary":{"missing":1,"version_too_old":0,"present":0,"not_applicable":0,"warning":0}}'
+    result = probes.evaluate(reason: "implementer_failed", now: NOW)
+    refute result.healthy
+    assert_equal "probe_failed:doctor", result.rationale
+  ensure
+    ENV.delete("HIVE_FAKE_DOCTOR_EXIT")
+    ENV.delete("HIVE_FAKE_DOCTOR_JSON")
+  end
+
+  def test_hanging_cli_hits_timeout_and_reports_unhealthy
+    ENV["HIVE_FAKE_CODEX_LOGIN_HANG"] = "30"
+    p = Hive::Daemon::HealthProbes.new(
+      hive_bin: @fake_hive,
+      codex_bin: @fake_codex,
+      env: ENV.to_hash,
+      codex_login_timeout_sec: 1
+    )
+    started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+    result = p.evaluate(reason: "implementer_failed", now: NOW)
+    elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+    refute result.healthy
+    assert_operator elapsed, :<, 5, "timeout should kill the child quickly, elapsed=#{elapsed}"
+  ensure
+    ENV.delete("HIVE_FAKE_CODEX_LOGIN_HANG")
+  end
+
+  def test_tick_cache_memoizes_within_same_now
+    p = probes
+    first = p.evaluate(reason: "implementer_failed", now: NOW)
+    # Flip env so a re-run would fail if not cached.
+    ENV["HIVE_FAKE_CODEX_LOGIN_EXIT"] = "1"
+    second = p.evaluate(reason: "implementer_failed", now: NOW)
+    assert_equal first.healthy, second.healthy
+    assert first.healthy
+  ensure
+    ENV.delete("HIVE_FAKE_CODEX_LOGIN_EXIT")
+  end
+
+  def test_fingerprint_changes_when_auth_json_mtime_changes
+    auth_dir = File.join(@tmpdir, "codex")
+    FileUtils.mkdir_p(auth_dir)
+    auth = File.join(auth_dir, "auth.json")
+    File.write(auth, "{}")
+    env = { "CODEX_HOME" => auth_dir, "HOME" => @tmpdir }
+    p = probes(env: env)
+    fp1 = p.fingerprint(now: NOW)
+    sleep 0.05
+    File.write(auth, '{"token":"x"}')
+    FileUtils.touch(auth, mtime: Time.now + 2)
+    fp2 = p.fingerprint(now: NOW)
+    refute_equal fp1, fp2
+  end
+
+  def test_fingerprint_stable_when_nothing_changes
+    p = probes
+    assert_equal p.fingerprint(now: NOW), p.fingerprint(now: NOW)
+  end
+
+  def test_claude_launcher_suite_requires_wrapper
+    p = probes
+    result = p.evaluate(reason: "claude_launch_failed", now: NOW)
+    # Wrapper ships with the gem, so healthy when doctor+version also pass.
+    # Version comes from fake hive --version matching Hive::VERSION.
+    ENV["HIVE_FAKE_HIVE_VERSION"] = Hive::VERSION
+    p2 = probes
+    result = p2.evaluate(reason: "claude_launch_failed", now: NOW)
+    assert result.healthy, "expected launcher suite healthy: #{result.inspect}"
+    assert result.probes["wrapper"]
+    assert result.probes["ready_detector"]
+    assert result.probes["binary_version"]
+    assert result.probes["doctor"]
+  ensure
+    ENV.delete("HIVE_FAKE_HIVE_VERSION")
+  end
+end
diff --git a/test/unit/daemon/stale_agent_healer_test.rb b/test/unit/daemon/stale_agent_healer_test.rb
index 158a6cf0..fc4633d7 100644
--- a/test/unit/daemon/stale_agent_healer_test.rb
+++ b/test/unit/daemon/stale_agent_healer_test.rb
@@ -71,8 +71,8 @@ class HiveDaemonStaleAgentHealerTest < Minitest::Test
     )
   end
 
-  def heal(rows, **opts)
-    @healer.heal(rows, now: NOW, **opts)
+  def heal(rows, now: NOW, **opts)
+    @healer.heal(rows, now: now, **opts)
   end
 
   def with_marker_file
@@ -2435,4 +2435,329 @@ class HiveDaemonStaleAgentHealerTest < Minitest::Test
       assert_equal 1, @logger.events.count { |name, _| name == :marker_heal_exhausted }
     end
   end
+
+  # --- Probe-gated auto-retry (implementer_failed codex_auth / claude_launch_failed) ---
+
+  class FakeHealthProbes
+    attr_reader :evaluate_calls, :fingerprint_calls
+    attr_accessor :healthy, :fingerprint, :rationale, :probes, :excerpts
+
+    def initialize(healthy: true, fingerprint: "fp-1")
+      @healthy = healthy
+      @fingerprint = fingerprint
+      @rationale = healthy ? "healthy" : "probe_failed:codex_smoke"
+      @probes = { "doctor" => healthy, "codex_login" => healthy, "codex_smoke" => healthy }
+      @excerpts = { "doctor" => "ok" }
+      @evaluate_calls = 0
+      @fingerprint_calls = 0
+    end
+
+    def fingerprint(now: nil)
+      @fingerprint_calls += 1
+      @fingerprint
+    end
+
+    def evaluate(reason:, now: nil)
+      @evaluate_calls += 1
+      Hive::Daemon::HealthProbes::ProbeResult.new(
+        healthy: @healthy,
+        fingerprint: @fingerprint,
+        probes: @probes,
+        excerpts: @excerpts,
+        rationale: @rationale
+      )
+    end
+  end
+
+  def build_probe_healer(probes:, auto_retry_enabled: true)
+    Hive::Daemon::StaleAgentHealer.new(
+      controller: @controller,
+      logger: @logger,
+      grace_sec: 300,
+      request_queue: @request_queue,
+      auto_retry_enabled: auto_retry_enabled,
+      health_probes: probes
+    )
+  end
+
+  def write_probe_error_marker(state_file, reason:, signature: nil, message: nil, marker_id: "m1")
+    attrs = " reason=#{reason}"
+    attrs += " signature=#{signature}" if signature
+    attrs += " message=\"#{message}\"" if message
+    attrs += " marker_id=#{marker_id}" if marker_id
+    File.write(state_file, "# task\n\n<!-- ERROR#{attrs} -->\n")
+  end
+
+  def make_probe_error_row(state_file, reason:, stage: "4-execute", signature: nil, message: nil, marker_id: "m1")
+    marker_attrs = { "reason" => reason }
+    marker_attrs["signature"] = signature if signature
+    marker_attrs["message"] = message if message
+    marker_attrs["marker_id"] = marker_id if marker_id
+    make_row(
+      state_file,
+      pid_alive: nil,
+      mtime: NOW - 1000,
+      stage: stage,
+      marker: "error",
+      marker_attrs: marker_attrs,
+      action: "error",
+      live_task_lock: false
+    )
+  end
+
+  def with_clean_execute_worktree
+    Dir.mktmpdir do |dir|
+      state_file = File.join(dir, "task.md")
+      worktree = File.join(dir, "wt")
+      FileUtils.mkdir_p(worktree)
+      system("git", "init", "-q", worktree)
+      system("git", "-C", worktree, "config", "user.email", "t@example.com")
+      system("git", "-C", worktree, "config", "user.name", "t")
+      File.write(File.join(worktree, "README"), "x")
+      system("git", "-C", worktree, "add", "README")
+      system("git", "-C", worktree, "commit", "-qm", "init")
+      File.write(File.join(dir, "worktree.yml"), { "path" => worktree }.to_yaml)
+      yield state_file, worktree
+    end
+  end
+
+  def test_probe_gated_clears_implementer_failed_with_codex_auth_signature
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", signature: "codex_auth")
+
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?,
+             "healthy probes must clear implementer_failed codex_auth"
+      cleared = @logger.events.select { |n, _| n == :auto_retry_cleared }
+      assert_equal 1, cleared.size
+      assert_equal "implementer_failed", cleared.first[1][:reason]
+      assert_equal "codex_auth", cleared.first[1][:signature]
+      assert_equal 1, cleared.first[1][:attempts]
+      assert_equal 1, probes.evaluate_calls
+      events_path = File.join(File.dirname(state_file), "events.jsonl")
+      assert File.file?(events_path), "task auto_retry event must be written"
+      assert_match(/auto_retry/, File.read(events_path))
+    end
+  end
+
+  def test_probe_gated_fallback_classifier_on_message_without_signature
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      msg = "401 Unauthorized: missing bearer token"
+      write_probe_error_marker(state_file, reason: "implementer_failed", message: msg)
+      row = make_probe_error_row(state_file, reason: "implementer_failed", message: msg)
+
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?
+      assert @logger.events.any? { |n, _| n == :auto_retry_cleared }
+    end
+  end
+
+  def test_unknown_implementer_failed_stays_parked_even_when_probes_green
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      write_probe_error_marker(state_file, reason: "implementer_failed", message: "exit_code=1")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", message: "exit_code=1")
+
+      heal([ row ])
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      refute @logger.events.any? { |n, _| n == :auto_retry_cleared }
+      assert_equal 0, probes.evaluate_calls, "unknown signature must not invoke probes"
+    end
+  end
+
+  def test_probe_gated_skips_when_probes_unhealthy
+    probes = FakeHealthProbes.new(healthy: false, fingerprint: "fp-a")
+    probes.rationale = "probe_failed:codex_smoke"
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", signature: "codex_auth")
+
+      heal([ row ])
+      heal([ row ]) # second tick — skip must be throttled
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      skips = @logger.events.select { |n, _| n == :auto_retry_skipped }
+      assert_equal 1, skips.size, "skip events are throttled per key+rationale"
+      assert_equal "probe_failed:codex_smoke", skips.first[1][:rationale]
+    end
+  end
+
+  def test_probe_gated_kill_switch_disables_without_probe_calls
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes, auto_retry_enabled: false)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", signature: "codex_auth")
+
+      heal([ row ])
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert_equal 0, probes.evaluate_calls
+      assert_equal 0, probes.fingerprint_calls
+      skips = @logger.events.select { |n, _| n == :auto_retry_skipped }
+      assert_equal 1, skips.size
+      assert_equal "disabled", skips.first[1][:rationale]
+    end
+  end
+
+  def test_kill_switch_does_not_disable_limits_reached_recovery
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes, auto_retry_enabled: false)
+
+    with_marker_file do |state_file|
+      past = (NOW - 60).iso8601
+      write_error_limit_marker(state_file, retry_after: past)
+      row = make_error_limit_row(state_file, retry_after: past)
+
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?,
+             "pre-existing limits_reached recovery must ignore auto_retry kill-switch"
+      assert @logger.events.any? { |n, a| n == :marker_healed && a[:reason] == "limits_reached" }
+    end
+  end
+
+  def test_probe_gated_dirty_worktree_skips
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-a")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, wt|
+      File.write(File.join(wt, "dirty.txt"), "user work")
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", signature: "codex_auth")
+
+      heal([ row ])
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      skips = @logger.events.select { |n, _| n == :auto_retry_skipped }
+      assert_equal 1, skips.size
+      assert_equal "dirty_worktree", skips.first[1][:rationale]
+      assert_equal 0, probes.evaluate_calls, "dirty guard runs before expensive probes"
+    end
+  end
+
+  def test_probe_gated_claude_launch_failed_clears_when_probes_healthy
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-cl")
+    probes.probes = { "wrapper" => true, "ready_detector" => true, "binary_version" => true, "doctor" => true }
+    @healer = build_probe_healer(probes: probes)
+
+    with_marker_file do |state_file|
+      write_probe_error_marker(state_file, reason: "claude_launch_failed")
+      row = make_probe_error_row(state_file, reason: "claude_launch_failed", stage: "3-plan")
+      # Empty plan.md is safe to re-seed.
+      File.write(File.join(File.dirname(state_file), "plan.md"), "")
+
+      heal([ row ])
+
+      assert Hive::Markers.current(state_file).none?
+      assert @logger.events.any? { |n, _| n == :auto_retry_cleared }
+      assert_equal 1, @request_queue.requests.size, "3-plan clear must requeue"
+    end
+  end
+
+  def test_probe_gated_plan_with_user_content_skips
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-cl")
+    @healer = build_probe_healer(probes: probes)
+
+    with_marker_file do |state_file|
+      write_probe_error_marker(state_file, reason: "claude_launch_failed")
+      File.write(File.join(File.dirname(state_file), "plan.md"), "# Plan\n\nUser answered: do the thing\n")
+      row = make_probe_error_row(state_file, reason: "claude_launch_failed", stage: "3-plan")
+
+      heal([ row ])
+
+      assert_match(/ERROR reason=claude_launch_failed/, File.read(state_file))
+      skips = @logger.events.select { |n, _| n == :auto_retry_skipped }
+      assert_equal 1, skips.size
+      assert_equal "plan_has_user_content", skips.first[1][:rationale]
+    end
+  end
+
+  def test_probe_gated_limits_backoff_and_fingerprint_and_exhaustion
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-1")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      row = make_probe_error_row(state_file, reason: "implementer_failed", signature: "codex_auth")
+
+      # First healthy signal → immediate clear.
+      @healer.heal([ row ], now: NOW)
+      assert Hive::Markers.current(state_file).none?
+      assert_equal 1, @logger.events.count { |n, _| n == :auto_retry_cleared }
+
+      # Marker reappears <30 min later → backoff (checked before fingerprint).
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      @healer.heal([ row ], now: NOW + 60)
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert @logger.events.any? { |n, a| n == :auto_retry_skipped && a[:rationale] == "backoff" }
+
+      # ≥30 min, same fingerprint → fingerprint_unchanged.
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      @healer.heal([ row ], now: NOW + 1800)
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert @logger.events.any? { |n, a| n == :auto_retry_skipped && a[:rationale] == "fingerprint_unchanged" }
+
+      # Fingerprint changed + ≥30 min → second retry.
+      probes.fingerprint = "fp-2"
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      @healer.heal([ row ], now: NOW + 1800)
+      assert Hive::Markers.current(state_file).none?
+      assert_equal 2, @logger.events.count { |n, _| n == :auto_retry_cleared }
+
+      # Third occurrence → exhausted once.
+      write_probe_error_marker(state_file, reason: "implementer_failed", signature: "codex_auth")
+      probes.fingerprint = "fp-3"
+      @healer.heal([ row ], now: NOW + 3600)
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      exhausted = @logger.events.select { |n, _| n == :auto_retry_exhausted }
+      assert_equal 1, exhausted.size
+      assert_match(/hive markers clear/, exhausted.first[1][:remediation])
+
+      # Further ticks stay silent on exhaustion.
+      @healer.heal([ row ], now: NOW + 7200)
+      assert_equal 1, @logger.events.count { |n, _| n == :auto_retry_exhausted }
+    end
+  end
+
+  def test_probe_gated_clear_race_does_not_consume_budget
+    probes = FakeHealthProbes.new(healthy: true, fingerprint: "fp-race")
+    @healer = build_probe_healer(probes: probes)
+
+    with_clean_execute_worktree do |state_file, _wt|
+      # On-disk marker_id differs from the status row → clear_current no-op.
+      write_probe_error_marker(state_file, reason: "implementer_failed",
+                              signature: "codex_auth", marker_id: "on-disk")
+      row = make_probe_error_row(state_file, reason: "implementer_failed",
+                                 signature: "codex_auth", marker_id: "stale-row")
+
+      heal([ row ])
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      refute @logger.events.any? { |n, _| n == :auto_retry_cleared }
+      # A subsequent heal with matching id still has full budget.
+      write_probe_error_marker(state_file, reason: "implementer_failed",
+                              signature: "codex_auth", marker_id: "m-ok")
+      row2 = make_probe_error_row(state_file, reason: "implementer_failed",
+                                  signature: "codex_auth", marker_id: "m-ok")
+      heal([ row2 ])
+      assert Hive::Markers.current(state_file).none?
+      assert_equal 1, @logger.events.count { |n, _| n == :auto_retry_cleared }
+    end
+  end
 end
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 28ac2224..014e690d 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -65,6 +65,22 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_auto_retry_event_is_allowed
+    with_tmp_dir do |dir|
+      Hive::Events.emit(
+        task_folder: dir,
+        slug: "event-test-260522-aaaa",
+        stage: "4-execute",
+        event_type: :auto_retry,
+        message: "auto_retry reason=implementer_failed signature=codex_auth attempt=1/2"
+      )
+
+      parsed = JSON.parse(File.read(File.join(dir, "events.jsonl")).lines.first)
+      assert_equal "auto_retry", parsed.fetch("event_type")
+      assert_match(/codex_auth/, parsed.fetch("message"))
+    end
+  end
+
   def test_status_md_rerenders_latest_event_and_recent_tail
     with_tmp_dir do |dir|
       Hive::Events.emit(task_folder: dir, slug: "event-test-260522-aaaa", stage: "6-review",
diff --git a/test/unit/failure_signature_test.rb b/test/unit/failure_signature_test.rb
new file mode 100644
index 00000000..66a143e5
--- /dev/null
+++ b/test/unit/failure_signature_test.rb
@@ -0,0 +1,49 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/failure_signature"
+
+class HiveFailureSignatureTest < Minitest::Test
+  def test_classifies_401_missing_bearer
+    text = "ERROR: unexpected status 401 Unauthorized: missing bearer token"
+    assert_equal "codex_auth", Hive::FailureSignature.classify(text)
+  end
+
+  def test_classifies_401_basic_auth
+    text = "HTTP 401: missing basic auth credentials for api.openai.com"
+    assert_equal "codex_auth", Hive::FailureSignature.classify(text)
+  end
+
+  def test_classifies_codex_not_authenticated
+    text = "codex: not authenticated — run `codex login`"
+    assert_equal "codex_auth", Hive::FailureSignature.classify(text)
+  end
+
+  def test_classifies_login_required_phrasing
+    text = "Please run `codex login` before using exec"
+    assert_equal "codex_auth", Hive::FailureSignature.classify(text)
+  end
+
+  def test_generic_test_failure_has_no_signature
+    text = "1) test_add fails: expected 4, got 5\nexit_code=1"
+    assert_nil Hive::FailureSignature.classify(text)
+  end
+
+  def test_bare_401_without_auth_phrasing_is_not_signature
+    # Conjunctive pattern: a status code alone must not auto-retry a
+    # business failure whose output merely mentions "401".
+    text = "upstream returned 401 pages of HTML for the fixture server"
+    assert_nil Hive::FailureSignature.classify(text)
+  end
+
+  def test_empty_and_nil_return_nil
+    assert_nil Hive::FailureSignature.classify(nil)
+    assert_nil Hive::FailureSignature.classify("")
+    assert_nil Hive::FailureSignature.classify("   ")
+  end
+
+  def test_case_insensitive
+    text = "ERROR 401 UNAUTHORIZED: MISSING BEARER"
+    assert_equal "codex_auth", Hive::FailureSignature.classify(text)
+  end
+end
diff --git a/test/unit/stages/execute_test.rb b/test/unit/stages/execute_test.rb
index af52b588..c4cf9045 100644
--- a/test/unit/stages/execute_test.rb
+++ b/test/unit/stages/execute_test.rb
@@ -163,6 +163,58 @@ class HiveStagesExecuteTest < Minitest::Test
       assert_equal "exit_code=1 compile error", marker.attrs["message"]
       refute marker.attrs.key?("retry_after")
       refute marker.attrs.key?("provider")
+      refute marker.attrs.key?("signature"),
+             "generic failure must not stamp a signature"
+    end
+  end
+
+  def test_run_pass_stamps_codex_auth_signature_from_output_tail
+    with_tmp_dir do |dir|
+      task = build_task(dir)
+      write_plan(task)
+      write_pointer(task, "path" => File.join(dir, "worktree"), "branch" => task.slug, "execute_base_head" => "base")
+      git = FakeGit.new(head: "base", branch: task.slug, dirty: false, ancestor_result: true)
+      result = {
+        status: :error,
+        error_message: "exit_code=1",
+        output_tail: "ERROR: unexpected status 401 Unauthorized: missing bearer token\n"
+      }
+
+      run_result = with_fake_git_and_spawn(git, result: result) do
+        Hive::Stages::Execute.run_pass(task, execute_cfg("codex"), File.join(dir, "worktree"))
+      end
+
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal({ commit: "implementer_failed", status: :error }, run_result)
+      assert_equal :error, marker.name
+      assert_equal "implementer_failed", marker.attrs["reason"]
+      assert_equal "codex_auth", marker.attrs["signature"]
+      assert_equal "exit_code=1", marker.attrs["message"]
+      assert marker.attrs.key?("marker_id")
+    end
+  end
+
+  def test_run_pass_limit_path_not_shadowed_by_signature
+    with_tmp_dir do |dir|
+      task = build_task(dir)
+      write_plan(task)
+      write_pointer(task, "path" => File.join(dir, "worktree"), "branch" => task.slug, "execute_base_head" => "base")
+      git = FakeGit.new(head: "base", branch: task.slug, dirty: false, ancestor_result: true)
+      result = {
+        status: :error,
+        limit_text: "you've hit your usage limit",
+        error_message: "exit_code=1",
+        output_tail: "401 Unauthorized missing bearer"
+      }
+
+      run_result = with_fake_git_and_spawn(git, result: result) do
+        Hive::Stages::Execute.run_pass(task, execute_cfg("codex"), File.join(dir, "worktree"))
+      end
+
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal({ commit: "limits_reached", status: :error }, run_result)
+      assert_equal "limits_reached", marker.attrs["reason"]
+      refute marker.attrs.key?("signature")
     end
   end
 
